$targetDirectory = [Nintendo.CPU.Profiler.Scripting.ScriptingCore]::NProfFilename
$nprofName = ""
if ([System.String]::IsNullOrEmpty($targetDirectory) -eq $false)
{
    $nprofName = [System.IO.Path]::GetFileName($targetDirectory)
    $targetDirectory = [System.IO.Path]::GetDirectoryName($targetDirectory)
}

$date = get-date

$reportFile = "report.txt"
if ([System.String]::IsNullOrEmpty($targetDirectory) -eq $false)
{
    $baseNprofName = [System.IO.Path]::GetFileNameWithoutExtension($nprofName)
    $reportFileName = $baseNprofName + "-report-" + $date.ToString("yyyyMMdd-HHmmss") + ".txt"
    $reportFile = [System.IO.Path]::Combine($targetDirectory, $reportFileName)
}

$report = "Report " + $date + [Environment]::NewLine + [Environment]::NewLine
$separator = [Environment]::NewLine + "________________________________________________________________________________" + [Environment]::NewLine

Profiler-TreeControl -Tab Info -Action ExpandAll
$infoTab = Profiler-Copy -Tab Info
$report += $infoTab + $separator

$functionsTab = Profiler-Copy -Tab Functions
$report += $functionsTab + $separator

$functionsTab = Profiler-Copy -Tab Threads
$report += $functionsTab + $separator

Profiler-TreeControl -Tab Instrumented -Action ExpandAll
$functionsTab = Profiler-Copy -Tab Instrumented
$report += $functionsTab + $separator

$functionsTab = Profiler-Copy -Tab Counters
$report += $functionsTab + $separator

Profiler-TreeControl -Tab CallTree -Action ExpandAll
$calltreeTab = Profiler-Copy -Tab CallTree -ExtendedParam All
$report += $calltreeTab + $separator

$codecoverageTabSeen = Profiler-Copy -Tab CodeCoverage -ExtendedParam Seen
$report += $codecoverageTabSeen + $separator

$codecoverageTabNotSeen = Profiler-Copy -Tab CodeCoverage -ExtendedParam NotSeen
$report += $codecoverageTabNotSeen + $separator

$report += "End Report"

$report | Out-File $reportFile
